/**
 *
 * @file spm_config.h.in
 *
 * Spm configuration parameters
 *
 * @copyright 2016-2017 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
 *                      Univ. Bordeaux. All rights reserved.
 *
 * @version 6.0.0
 * @author Pierre Ramet
 * @author Mathieu Faverge
 * @date 2017-09-28
 *
 **/
#ifndef _spm_config_h_
#define _spm_config_h_

#define SPM_VERSION_MAJOR 1
#define SPM_VERSION_MINOR 0
#define SPM_VERSION_MICRO 0

#define SPM_WITH_FORTRAN
/* #undef SPM_WITH_MPI */

/* system */
#define HAVE_CLOCK_GETTIME
#define HAVE_ASPRINTF
#define HAVE_VASPRINTF
#define HAVE_STDARG_H
#define HAVE_UNISTD_H
#define HAVE_VA_COPY
/* #undef HAVE_UNDERSCORE_VA_COPY */
#define HAVE_GETOPT_LONG
#define HAVE_GETRUSAGE
#define HAVE_GETOPT_H
#define HAVE_ERRNO_H
#define HAVE_STDDEF_H
#define HAVE_LIMITS_H
#define HAVE_STRING_H
#define HAVE_COMPLEX_H
#define HAVE_FALLTHROUGH

/* Datatypes used */
/* #undef SPM_INT64 */

/* Exploit the scotch version from the library compiling spm */
#define HAVE_SCOTCH

/* LAPACKE */
#define LAPACKE_WITH_LASCL

#if defined(HAVE_FALLTHROUGH)
#define spm_attr_fallthrough __attribute__((fallthrough))
#else
#define spm_attr_fallthrough do {} while(0)
#endif

#if defined(WIN32) || defined(_WIN32)
#define SPM_OS_WINDOWS 1
#endif

/*
 * BEGIN_C_DECLS should be used at the beginning of your declarations,
 * so that C++ compilers don't mangle their names.  Use END_C_DECLS at
 * the end of C declarations.
 */
#undef BEGIN_C_DECLS
#undef END_C_DECLS
#if defined(c_plusplus) || defined(__cplusplus)
# define BEGIN_C_DECLS extern "C" {
# define END_C_DECLS }
#else
#define BEGIN_C_DECLS          /* empty */
#define END_C_DECLS            /* empty */
#endif

#endif /* _spm_config_h_ */
